/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ca.mcscert.jtet.cvc3generator;

import ca.mcscert.jtet.expression.BinaryOperation;
import ca.mcscert.jtet.expression.FixedPointVariableType;
import ca.mcscert.jtet.expression.Literal;
import ca.mcscert.jtet.expression.RealVariableType;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.JUnit4;
import static org.junit.Assert.*;

/**
 *
 * @author matthew
 */
@RunWith(JUnit4.class)
public class CVC3ExpressionGeneratorTest {
    /**
     * Test of addition operation.
     */
    @Test
    public void testAdditionOpConverstion() {
        BinaryOperation op = BinaryOperation.Addition;
        assertEquals("+", CVC3ExpressionGenerator.ConvertToOutputOp(op, RealVariableType.Type));
        assertEquals("BVPLUS(13,", CVC3ExpressionGenerator.ConvertToOutputOp(op, new FixedPointVariableType(true, 13, 5)));
    }
    /**
     * Test of literals containing decimals.
     *
     * All decimals must be represented as fractions.  Ensure that this happens.
     */
    @Test
    public void testLiteralRationalsAreFractions() {
        Literal literal = new Literal("4.56");
        assertEquals("(456/100)", literal.getCheckerOutput(new CVC3ExpressionGenerator(), RealVariableType.Type));
    }
}
